<template>
  <section>
    <template v-for="(component, i) in page.fields.components">
      <div :key="component.sys.id" class="component">
        <b-breadcrumb v-if="i === 1" :items="items" />
        <b-btn
          v-b-modal="component.sys.id"
          v-b-modal.modal1
          size="sm"
          class="component-preview"
        >
          Component: {{ component.sys.contentType.sys.id }}</b-btn
        >
        <b-modal
          :id="component.sys.id"
          size="lg"
          :title="'Component Type: ' + component.sys.contentType.sys.id"
          centered
        >
          <!-- {{ component }} -->
          <div class="table-responsive">
            <table class="table">
              <tbody>
                <tr>
                  <th>Component ID</th>
                  <td>{{ component.sys.id }}</td>
                </tr>
                <template v-for="(field, key, index) in component.fields">
                  <tr :key="index">
                    <th>fields.{{ key }}</th>
                    <td>{{ field }}</td>
                  </tr>
                </template>
                <tr>
                  <td colspan="2">
                    <pre>{{ component }}</pre>
                  </td>
                </tr>
              </tbody>
            </table>
          </div>
        </b-modal>

        <component
          :is="component.sys.contentType.sys.id"
          :fields="component.fields"
        />
      </div>
    </template>
    <div v-if="page.fields.title == 'Contact Us'">
      <div class="container-fluid my-5">
        <form
          name="contact"
          method="POST"
          data-netlify-recaptcha="true"
          data-netlify="true"
        >
          <h3 class="border-bottom">Contact form</h3>

          <div class="row">
            <div class="form-group col-sm-6">
              <label class="control-label" for="name">Name</label>
              <input
                id="name"
                size="60"
                type="text"
                placeholder=""
                required="required"
                class="form-control"
                maxlength="50"
                name="name"
                value=""
              />
            </div>
            <div class="form-group col-sm-6" style="">
              <label for="company-name">Company name</label
              ><input
                id="company-name"
                minlength="1"
                aria-describedby="company-name"
                class="form-control"
                maxlength="50"
                name="company-name"
                placeholder=""
                type="text"
                value=""
              />
            </div>
          </div>

          <div class="row">
            <div class="form-group col-sm-6" style="">
              <label for="phone">Telephone</label
              ><input
                id="phone"
                minlength="1"
                pattern="((\+)|(00)?)[0-9]{7,12}$"
                aria-describedby="phone"
                class="form-control"
                maxlength="30"
                name="phone"
                placeholder="ie. +353 87 1234567"
                type="tel"
                value=""
              />
            </div>
            <div class="form-group col-sm-6">
              <label class="control-label" for="email">Email</label>
              <input
                id="email"
                size="60"
                aria-describedby="email"
                type="email"
                placeholder=""
                data-error="Please enter a valid email address"
                required="required"
                maxlength="50"
                class="form-control"
                name="email"
                value=""
              />
            </div>
          </div>

          <div class="row">
            <div class="form-group col-sm-12">
              <label class="control-label" for="message">Message</label>
              <textarea
                id="message"
                class="form-control"
                name="message"
                required=""
                rows="3"
              ></textarea>
            </div>
          </div>

          <div data-netlify-recaptcha="true"></div>

          <button class="btn btn-lg btn-primary" type="submit">
            Submit
          </button>
        </form>
      </div>
    </div>
  </section>
</template>

<script>
import client from '~/plugins/contentful'

export default {
  components: {
    HeroBanner: () => import('~/components/HeroBanner.vue'),
    Feature: () => import('~/components/Feature.vue'),
    SubpageHeader: () => import('~/components/SubpageHeader.vue'),
    ContentBlock: () => import('~/components/ContentBlock.vue'),
    PageCta: () => import('~/components/Promo.vue')
  },
  data() {
    return {
      page: Object,
      items: [
        {
          text: 'Home',
          href: '/'
        },
        {
          text: 'Page Title',
          active: true
        }
      ]
    }
  },
  asyncData({ params }) {
    return client
      .getEntries({
        content_type: 'page',
        'fields.slug': params.slug
      })
      .then(pages => {
        return {
          page: pages.items[0]
        }
      })
      .catch(console.error)
  },
  head() {
    return {
      title: this.page.fields.title
    }
  }
}
</script>

<style scoped lang="scss">
@import './assets/scss/bootstrap-variable-override';
.component {
  position: relative;
}
.component-preview {
  position: absolute;
  top: 20px;
  right: 20px;
  z-index: 1000;
}
</style>
